package com.madeu.crm.categoryManagement.ctrl;

import java.util.HashMap;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.servlet.ModelAndView;

import com.madeu.constants.Constants;
import com.madeu.crm.categoryManagement.service.CategoryManagementService;
import com.madeu.service.web.webloghistory.WebLogHistoryService;
import com.madeu.util.HttpUtil;
import com.madeu.util.RequestLogUtil;

import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import jakarta.servlet.http.HttpSession;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@Controller
public class CategoryManagementController {

    @Autowired
    private CategoryManagementService categoryManagementService;

    @Autowired
    private WebLogHistoryService webLogHistoryService;

    /**
     * 카테고리 게시판 이동
     *
     * @param request
     * @param response
     * @return
     */
    @PostMapping("/categoryManagement/moveCategoryManagementList.do")
    public String  moveCategoryManagementList(HttpSession session, HttpServletRequest request, HttpServletResponse response, Model model) {
        log.debug("moveCategoryManagementList START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
            map = categoryManagementService.moveCategoryManagementList(paramMap);

            model.addAttribute("selectUseYn", map.get("selectUseYn"));
            model.addAttribute("insertUseYn", map.get("insertUseYn"));
            model.addAttribute("updateUseYn", map.get("updateUseYn"));
            model.addAttribute("deleteUseYn", map.get("deleteUseYn"));
            model.addAttribute("downloadUseYn", map.get("downloadUseYn"));
        }
        catch (Exception e) {
            e.printStackTrace();
            return "/web/login/logout";
        }
        log.debug("moveCategoryManagementList END");

        
        return "/web/categoryManagement/CategoryManagementList";
    }
    
    
    /**
     * 카테고리 게시판 조회
     *
     * @param request
     * @param response
     * @return
     */
    @PostMapping("/categoryManagement/getCategoryManagementList.do")
    public ModelAndView getCategoryManagementList(HttpSession session, HttpServletRequest request, HttpServletResponse response) {
		log.debug("CategoryManagementController selectListCategoryManagement START");
		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
            map = categoryManagementService.getCategoryManagementList(paramMap);
        }
        catch (Exception e) {
            e.printStackTrace();
            return null;
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }
        }
        log.debug("CategoryManagementController selectListCategoryManagement END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }
    /**
     * 홈페이지 카테고리 정보 상세 조회
     *
     * @param request
     * @param response
     * @return
     */
    @PostMapping("/categoryManagement/getCategoryManagement.do")
    public ModelAndView getCategoryManagement(HttpSession session,HttpServletRequest request, HttpServletResponse response) {
        log.debug("CategoryManagementController selectCategoryManagement START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
            map = categoryManagementService.getCategoryManagement(paramMap);
        }
        catch (Exception e) {
            e.printStackTrace();
            return null;
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }
        }
        log.debug("CategoryManagementController selectCategoryManagement END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }
    
    /**
     * 홈페이지 카테고리 정보 등록
     *
     * @param request
     * @param response
     * @return
     */
    @PostMapping(value="/categoryManagement/putCategoryManagement.do")
    public ModelAndView putCategoryManagement(@RequestBody HashMap<String, Object> paramMap, HttpSession session,HttpServletRequest request, HttpServletResponse response) {
        log.debug("CategoryManagementController putCategoryManagement START");

        HashMap<String, Object> map = new HashMap<String, Object>();
        StringBuffer errorMsg = new StringBuffer();

        try{
            paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
            paramMap.put("regId", String.valueOf(session.getAttribute("loginMemberId")));
            paramMap.put("modId", String.valueOf(session.getAttribute("loginMemberId")));
            map = categoryManagementService.putCategoryManagement(paramMap);
        }
        catch (Exception e) {
            e.printStackTrace();
            errorMsg.append(e);
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }

            try {
                HashMap<String, Object> visitLogParamMap = RequestLogUtil.getVisitLogParameterMap(request);
                HashMap<String, Object> insertMap = new HashMap<String, Object>();

                insertMap.put("url", "/CategoryManagement/insertCategoryManagement.do");
                insertMap.put("func", "insertCategoryManagement");
                insertMap.put("funcName", "홈페이지 카테고리 등록");
                insertMap.put("service", "CategoryManagementService");
                insertMap.put("serviceName", "홈페이지 카테고리 등록");
                insertMap.put("requestValue", String.valueOf(paramMap));
                insertMap.put("responseValue", String.valueOf(map));
                insertMap.put("tId", map.get("tId"));
                if((String.valueOf(errorMsg)).equals("") || (String.valueOf(errorMsg) == null) || String.valueOf(errorMsg).length() == 0){
                    insertMap.put("resultCode", "SUCCESS");
                }
                else{
                    insertMap.put("resultCode", "ERROR");
                }
                insertMap.put("resultMsg", String.valueOf(errorMsg));
                insertMap.put("muMemberId", paramMap.get("loginMemberId"));

                webLogHistoryService.insertLogHistory(insertMap, visitLogParamMap);
            }
            catch (Exception e) {
                e.printStackTrace();
            }
        }
        log.debug("CategoryManagementController putCategoryManagement END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }

    

    /**
     * 홈페이지 카테고리 정보 수정
     *
     * @param request
     * @param response
     * @return
     */
    @PostMapping(value="/categoryManagement/modCategoryManagement.do")
    public ModelAndView modCategoryManagement(@RequestBody HashMap<String, Object> paramMap, HttpSession session,HttpServletRequest request, HttpServletResponse response) {
        log.debug("CategoryManagementController updateCategoryManagement START");

        HashMap<String, Object> map = new HashMap<String, Object>();

        StringBuffer errorMsg = new StringBuffer();

        try{
            paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
            paramMap.put("regId", String.valueOf(session.getAttribute("loginMemberId")));
            paramMap.put("modId", String.valueOf(session.getAttribute("loginMemberId")));
            map = categoryManagementService.modCategoryManagement(paramMap);
        }
        catch (Exception e) {
            e.printStackTrace();
            errorMsg.append(e);
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }

            try {
                HashMap<String, Object> visitLogParamMap = RequestLogUtil.getVisitLogParameterMap(request);
                HashMap<String, Object> insertMap = new HashMap<String, Object>();

                insertMap.put("url", "/CategoryManagement/updateCategoryManagement.do");
                insertMap.put("func", "updateCategoryManagement");
                insertMap.put("funcName", "홈페이지 카테고리 수정");
                insertMap.put("service", "CategoryManagementService");
                insertMap.put("serviceName", "홈페이지 카테고리 수정");
                insertMap.put("requestValue", String.valueOf(paramMap));
                insertMap.put("responseValue", String.valueOf(map));
                insertMap.put("tId", map.get("tId"));
                if((String.valueOf(errorMsg)).equals("") || (String.valueOf(errorMsg) == null) || String.valueOf(errorMsg).length() == 0){
                    insertMap.put("resultCode", "SUCCESS");
                }
                else{
                    insertMap.put("resultCode", "ERROR");
                }
                insertMap.put("resultMsg", String.valueOf(errorMsg));
                insertMap.put("muMemberId", paramMap.get("loginMemberId"));

                webLogHistoryService.insertLogHistory(insertMap, visitLogParamMap);
            }
            catch (Exception e) {
                e.printStackTrace();
            }
        }
        log.debug("CategoryManagementController updateCategoryManagement END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }


    
    /**
     * 홈페이지 카테고리 정보 삭제
     *
     * @param request
     * @param response
     * @return
     */
    @PostMapping(value="/categoryManagement/delCategoryManagement.do")
    public ModelAndView delCategoryManagement(@RequestBody HashMap<String, Object> paramMap, HttpSession session, HttpServletRequest request, HttpServletResponse response) {
        log.debug("CategoryManagementController delCategoryManagement START");

        HashMap<String, Object> map = new HashMap<String, Object>();
        StringBuffer errorMsg = new StringBuffer();

        try{
            paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
            paramMap.put("modId", String.valueOf(session.getAttribute("loginMemberId")));
            map = categoryManagementService.delCategoryManagement(paramMap);
        }
        catch (Exception e) {
            e.printStackTrace();
            errorMsg.append(e);
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }

            try {
                HashMap<String, Object> visitLogParamMap = RequestLogUtil.getVisitLogParameterMap(request);
                HashMap<String, Object> insertMap = new HashMap<String, Object>();

                insertMap.put("url", "/CategoryManagement/delCategoryManagement.do");
                insertMap.put("func", "delCategoryManagement");
                insertMap.put("funcName", "홈페이지 카테고리 삭제");
                insertMap.put("service", "CategoryManagementService");
                insertMap.put("serviceName", "홈페이지 카테고리 삭제");
                insertMap.put("requestValue", String.valueOf(paramMap));
                insertMap.put("responseValue", String.valueOf(map));
                insertMap.put("tId", map.get("tId"));
                if((String.valueOf(errorMsg)).equals("") || (String.valueOf(errorMsg) == null) || String.valueOf(errorMsg).length() == 0){
                    insertMap.put("resultCode", "SUCCESS");
                }
                else{
                    insertMap.put("resultCode", "ERROR");
                }
                insertMap.put("resultMsg", String.valueOf(errorMsg));
                insertMap.put("muMemberId", paramMap.get("loginMemberId"));

                webLogHistoryService.insertLogHistory(insertMap, visitLogParamMap);
            }
            catch (Exception e) {
                e.printStackTrace();
            }
        }
        log.debug("CategoryManagementController delCategoryManagement END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }
}